## s390-tools 2.15.1

=== genprotimg/Makefile ===
# Common definitions
include ../common.mak

.DEFAULT_GOAL := all

PKGDATADIR := "$(DESTDIR)$(TOOLS_DATADIR)/genprotimg"
TESTS :=
SUBDIRS := boot src man
RECURSIVE_TARGETS := all-recursive install-recursive clean-recursive

all: all-recursive

install: all install-recursive
	$(INSTALL) -d -m 755 "$(PKGDATADIR)"
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 boot/stage3a.bin "$(PKGDATADIR)"
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 boot/stage3b_reloc.bin "$(PKGDATADIR)"
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 samples/check_hostkeydoc "$(PKGDATADIR)"

clean: clean-recursive

$(RECURSIVE_TARGETS):
	@target=`echo $@ |sed s/-recursive//`; \
		for d in $(SUBDIRS); do \
			$(MAKE) -C $$d $$target; \
		done

.PHONY: all install clean $(RECURSIVE_TARGETS)

=== libekmfweb/Makefile ===
include ../common.mak

VERSION = 1.0
VERM = $(shell echo $(VERSION) | cut -d '.' -f 1)

ifneq (${HAVE_OPENSSL},0)
	ifneq (${HAVE_JSONC},0)
		ifneq (${HAVE_LIBCURL},0)
			BUILD_TARGETS += libekmfweb.so.$(VERSION)
			INSTALL_TARGETS += install-libekmfweb.so.$(VERSION)
		else
			BUILD_TARGETS += skip-libekmfweb-curl
			INSTALL_TARGETS += skip-libekmfweb-curl
		endif
	else
		BUILD_TARGETS += skip-libekmfweb-jsonc
		INSTALL_TARGETS += skip-libekmfweb-jsonc
	endif
else
	BUILD_TARGETS += skip-libekmfweb-openssl
	INSTALL_TARGETS += skip-libekmfweb-openssl
endif

libs = $(rootdir)/libutil/libutil.a

detect-openssl-version.dep:
	echo "#include <openssl/opensslv.h>" > detect-openssl-version.dep
	echo "#include <openssl/evp.h>" >> detect-openssl-version.dep
	echo "#if OPENSSL_VERSION_NUMBER < 0x10101000L" >> detect-openssl-version.dep
	echo "  #error openssl version 1.1.1 is required" >> detect-openssl-version.dep
	echo "#endif" >> detect-openssl-version.dep
	echo "static void __attribute__((unused)) test(void) {" >> detect-openssl-version.dep
	echo "    EVP_PKEY_meth_remove(NULL);" >> detect-openssl-version.dep
	echo "}" >> detect-openssl-version.dep

check-dep-libekmfweb: detect-openssl-version.dep
	$(call check_dep, \
		"libekmfweb", \
		"detect-openssl-version.dep", \
		"openssl-devel version >= 1.1.1", \
		"HAVE_OPENSSL=0", \
		-I. -lcrypto)
	$(call check_dep, \
		"libekmfweb", \
		"json-c/json.h", \
		"json-c-devel", \
		"HAVE_JSONC=0")
	$(call check_dep, \
		"libekmfweb", \
		"curl/curl.h", \
		"libcurl-devel", \
		"HAVE_LIBCURL=0")
	touch check-dep-libekmfweb

skip-libekmfweb-openssl:
	echo "  SKIP    libekmfweb due to HAVE_OPENSSL=0"

skip-libekmfweb-jsonc:
	echo "  SKIP    libekmfweb due to HAVE_JSONC=0"

skip-libekmfweb-curl:
	echo "  SKIP    libekmfweb due to HAVE_LIBCURL=0"

all: $(BUILD_TARGETS)

ekmfweb.o: check-dep-libekmfweb ekmfweb.c utilities.h cca.h $(rootdir)include/ekmfweb/ekmfweb.h
utilities.o: check-dep-libekmfweb utilities.c utilities.h $(rootdir)include/ekmfweb/ekmfweb.h
cca.o: check-dep-libekmfweb cca.c cca.h utilities.h $(rootdir)include/ekmfweb/ekmfweb.h

libekmfweb.so.$(VERSION): ALL_CFLAGS += -fPIC
libekmfweb.so.$(VERSION): LDLIBS = -ljson-c -lcrypto -lssl -lcurl -ldl
libekmfweb.so.$(VERSION): ALL_LDFLAGS += -shared -Wl,--version-script=libekmfweb.map \
	-Wl,-z,defs,-Bsymbolic -Wl,-soname,libekmfweb.so.$(VERM)
libekmfweb.so.$(VERSION): ekmfweb.o utilities.o cca.o
	$(LINK) $(ALL_LDFLAGS) $^ $(LDLIBS) -o $@
	ln -srf libekmfweb.so.$(VERSION) libekmfweb.so.$(VERM)
	ln -srf libekmfweb.so.$(VERSION) libekmfweb.so

install-libekmfweb.so.$(VERSION): libekmfweb.so.$(VERSION)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 -T libekmfweb.so.$(VERSION) $(DESTDIR)$(USRLIB64DIR)/libekmfweb.so.$(VERSION)
	ln -srf $(DESTDIR)$(USRLIB64DIR)/libekmfweb.so.$(VERSION) $(DESTDIR)$(USRLIB64DIR)/libekmfweb.so.$(VERM)
	ln -srf $(DESTDIR)$(USRLIB64DIR)/libekmfweb.so.$(VERSION) $(DESTDIR)$(USRLIB64DIR)/libekmfweb.so
	$(INSTALL) -d -m 770 $(DESTDIR)$(USRINCLUDEDIR)/ekmfweb
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 $(rootdir)include/ekmfweb/ekmfweb.h $(DESTDIR)$(USRINCLUDEDIR)/ekmfweb

install: all $(INSTALL_TARGETS)

clean:
	rm -f *.o libekmfweb.so* check-dep-libekmfweb detect-openssl-version.dep

.PHONY: all install clean skip-libekmfweb-openssl skip-libekmfweb-jsonc \
	skip-libekmfweb-curl install-libekmfweb.so.$(VERSION)

=== lsstp/Makefile ===
include ../common.mak

libs = $(rootdir)/libutil/libutil.a
all: lsstp

lsstp: lsstp.o $(libs)

install: all
	$(INSTALL) -d -m 755 $(DESTDIR)$(BINDIR) \
		$(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 lsstp $(DESTDIR)$(BINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 lsstp.8 \
		$(DESTDIR)$(MANDIR)/man8

clean:
	rm -f *.o *~ lsstp core

.PHONY: all install clean

=== osasnmpd/Makefile ===
include ../common.mak
LDLIBS = `net-snmp-config --agent-libs`
# On some Linux systems `net-snmp-config --agent-libs` introduces -pie,
# therefore add -fPIC to prevent link failures.
ALL_CFLAGS += -fPIC
ALL_CFLAGS += `net-snmp-config --cflags`

OBJS = ibmOSAMib.o ibmOSAMibUtil.o osasnmpd.o

ifeq (${HAVE_SNMP},0)

all:
	$(SKIP) HAVE_SNMP=0

install:
	$(SKIP) HAVE_SNMP=0

else

check_dep:
	$(call check_dep, \
		"osasnmpd", \
		"net-snmp/net-snmp-config.h", \
		"net-snmp-devel or libsnmp-dev", \
		"HAVE_SNMP=0")

all: check_dep osasnmpd

osasnmpd: $(OBJS)

install: all
	$(INSTALL) -d -m 755 $(DESTDIR)$(USRSBINDIR) $(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 osasnmpd \
		$(DESTDIR)$(USRSBINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 osasnmpd.8 \
		$(DESTDIR)$(MANDIR)/man8

endif

clean:
	rm -f $(OBJS) osasnmpd core

.PHONY: all install clean

=== zdsfs/Makefile ===
include ../common.mak

libs =	$(rootdir)/libzds/libzds.a \
	$(rootdir)/libvtoc/libvtoc.a \
	$(rootdir)/libdasd/libdasd.a \
	$(rootdir)/libutil/libutil.a

ifeq (${HAVE_FUSE},0)

all:
	$(SKIP) HAVE_FUSE=0

install:
	$(SKIP) HAVE_FUSE=0


else

ifeq (${HAVE_CURL},0)

all:
	$(SKIP) HAVE_CURL=0

install:
	$(SKIP) HAVE_CURL=0

else

check_dep:
	$(call check_dep, \
		"zdsfs", \
		"fuse.h", \
		"fuse-devel or libfuse-dev", \
		"HAVE_FUSE=0")
	$(call check_dep, \
		"zdsfs", \
		"curl/curl.h", \
		"curl-devel or libcurl-dev", \
		"HAVE_CURL=0")

ifneq ($(shell sh -c 'command -v pkg-config'),)
FUSE_CFLAGS = $(shell pkg-config --silence-errors --cflags fuse)
FUSE_LDLIBS = $(shell pkg-config --silence-errors --libs fuse)
CURL_CFLAGS = $(shell pkg-config --silence-errors --cflags libcurl)
CURL_LDLIBS = $(shell pkg-config --silence-errors --libs libcurl)
else
FUSE_CFLAGS = -D_FILE_OFFSET_BITS=64 -I/usr/include/fuse
FUSE_LDLIBS = -lfuse
CURL_CFLAGS = -I/usr/include/s390x-linux-gnu/curl
CURL_LDLIBS = -lcurl
endif
ALL_CPPFLAGS += -DSYSFS
ALL_CFLAGS += -DHAVE_SETXATTR -pthread $(FUSE_CFLAGS) $(CURL_CFLAGS)
LDLIBS += $(FUSE_LDLIBS) $(CURL_LDLIBS) -lpthread -lrt -lm

all: check_dep zdsfs

zdsfs: zdsfs.o $(libs)

install: all
	$(INSTALL) -d -m 755 $(DESTDIR)$(USRBINDIR) $(DESTDIR)$(MANDIR)/man1
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 zdsfs $(DESTDIR)$(USRBINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 zdsfs.1 \
		$(DESTDIR)$(MANDIR)/man1

endif

endif

clean:
	rm -f *.o *~ zdsfs core

.PHONY: all install clean

=== zkey/Makefile ===
include ../common.mak

ifneq (${HAVE_OPENSSL},0)
	BUILD_TARGETS += zkey
	INSTALL_TARGETS += install-zkey
	ifneq (${HAVE_JSONC},0)
		ifneq (${HAVE_LIBCURL},0)
			SUB_DIRS += ekmfweb
		endif
	endif
else
	BUILD_TARGETS += zkey-skip
	INSTALL_TARGETS += zkey-skip
endif

ifneq (${HAVE_CRYPTSETUP2},0)
	ifneq (${HAVE_JSONC},0)
		ifneq (${HAVE_OPENSSL},0)
			BUILD_TARGETS += zkey-cryptsetup
			INSTALL_TARGETS += install-zkey-cryptsetup
			CPPFLAGS += -DHAVE_LUKS2_SUPPORT
		else
			BUILD_TARGETS += zkey-cryptsetup-skip-openssl
			INSTALL_TARGETS += zkey-cryptsetup-skip-openssl
		endif
	else
		BUILD_TARGETS += zkey-cryptsetup-skip-jsonc
		INSTALL_TARGETS += zkey-cryptsetup-skip-jsonc
	endif
else
	BUILD_TARGETS += zkey-cryptsetup-skip-cryptsetup2
	INSTALL_TARGETS += zkey-cryptsetup-skip-cryptsetup2
endif

libs = $(rootdir)/libutil/libutil.a

detect-libcryptsetup.dep:
	echo "#include <libcryptsetup.h>" > detect-libcryptsetup.dep
	echo "#ifndef CRYPT_LUKS2" >> detect-libcryptsetup.dep
	echo "  #error libcryptsetup version 2.0.3 is required" >> detect-libcryptsetup.dep
	echo "#endif" >> detect-libcryptsetup.dep
	echo "int i = CRYPT_SLOT_UNBOUND;" >> detect-libcryptsetup.dep

check-dep-zkey:
	$(call check_dep, \
		"zkey", \
		"openssl/evp.h", \
		"openssl-devel", \
		"HAVE_OPENSSL=0")
	touch check-dep-zkey

check-dep-zkey-cryptsetup: detect-libcryptsetup.dep
	$(call check_dep, \
		"zkey-cryptsetup", \
		"detect-libcryptsetup.dep", \
		"cryptsetup-devel version 2.0.3", \
		"HAVE_CRYPTSETUP2=0", \
		"-I.")
	$(call check_dep, \
		"zkey-cryptsetup", \
		"json-c/json.h", \
		"json-c-devel", \
		"HAVE_JSONC=0")
	touch check-dep-zkey-cryptsetup

zkey-skip:
	echo "  SKIP    zkey due to HAVE_OPENSSL=0"

zkey-cryptsetup-skip-cryptsetup2:
	echo "  SKIP    zkey-cryptsetup due to HAVE_CRYPTSETUP2=0"

zkey-cryptsetup-skip-jsonc:
	echo "  SKIP    zkey-cryptsetup due to HAVE_JSONC=0"

zkey-cryptsetup-skip-openssl:
	echo "  SKIP    zkey-cryptsetup due to HAVE_OPENSSL=0"

all: $(BUILD_TARGETS) $(SUB_DIRS)

zkey.o: zkey.c pkey.h cca.h ep11.h misc.h
pkey.o: pkey.c pkey.h cca.h ep11.h utils.h
cca.o: cca.c cca.h pkey.h ep11.h utils.h
ep11.o: ep11.c ep11.h pkey.h cca.h utils.h
utils.o: utils.h pkey.h cca.h ep11.h
properties.o: check-dep-zkey properties.c properties.h
keystore.o: keystore.c keystore.h properties.h pkey.h cca.h ep11.h utils.h
zkey-cryptsetup.o: check-dep-zkey-cryptsetup zkey-cryptsetup.c pkey.h cca.h \
			ep11.h misc.h utils.h
kms.o: kms.c kms.h kms-plugin.h utils.h pkey.h

zkey: LDLIBS = -ldl -lcrypto
zkey: zkey.o pkey.o cca.o ep11.o properties.o keystore.o utils.o kms.o $(libs)
	$(LINK) $(ALL_LDFLAGS) $^ $(LDLIBS) -o $@

zkey-cryptsetup: LDLIBS = -ldl -lcryptsetup -ljson-c -lcrypto
zkey-cryptsetup: zkey-cryptsetup.o pkey.o cca.o ep11.o utils.o $(libs)
	$(LINK) $(ALL_LDFLAGS) $^ $(LDLIBS) -o $@

install-common:
	$(INSTALL) -d -m 755 $(DESTDIR)$(USRBINDIR)
	$(INSTALL) -d -m 755 $(DESTDIR)$(MANDIR)/man1

install-zkey: zkey
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 zkey $(DESTDIR)$(USRBINDIR)
	$(INSTALL) -m 644 -c zkey.1 $(DESTDIR)$(MANDIR)/man1
	$(INSTALL) -d -m 770 $(DESTDIR)$(SYSCONFDIR)/zkey
	$(INSTALL) -d -m 770 $(DESTDIR)$(SYSCONFDIR)/zkey/repository
	$(INSTALL) -m 644 -c kms-plugins.conf $(DESTDIR)$(SYSCONFDIR)/zkey

install-zkey-cryptsetup: zkey-cryptsetup
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 zkey-cryptsetup $(DESTDIR)$(USRBINDIR)
	$(INSTALL) -m 644 -c zkey-cryptsetup.1 $(DESTDIR)$(MANDIR)/man1

install: all install-common $(INSTALL_TARGETS) $(SUB_DIRS)

clean: $(SUB_DIRS)
	rm -f *.o zkey zkey-cryptsetup detect-libcryptsetup.dep \
		check-dep-zkey check-dep-zkey-cryptsetup

#
# For simple "make" we explicitly set the MAKECMDGOALS to "all".
#
ifeq ($(MAKECMDGOALS),)
MAKECMDGOALS = all
endif

$(SUB_DIRS):
	$(foreach goal,$(MAKECMDGOALS), \
		$(MAKE) -C $@ TOPDIR=$(TOPDIR) ARCH=$(ARCH) $(goal) ;)
.PHONY: $(SUB_DIRS)

.PHONY: all install clean zkey-skip zkey-cryptsetup-skip-cryptsetup2 \
	zkey-cryptsetup-skip-jsonc install-common install-zkey \
	install-zkey-cryptsetup

=== genprotimg/src/Makefile ===
# Common definitions
include ../../common.mak

bin_PROGRAM = genprotimg

PKGDATADIR ?= "$(DESTDIR)$(TOOLS_DATADIR)/genprotimg"
SRC_DIR := $(dir $(realpath $(firstword $(MAKEFILE_LIST))))
TOP_SRCDIR := $(SRC_DIR)/../
ROOT_DIR = $(TOP_SRC_DIR)/../../
ZIPL_DIR = $(ROOT_DIR)/zipl
LOADER_DIR = $(TOP_SRCDIR)/boot

INCLUDE_PATHS = "$(SRC_DIR)" "$(TOP_SRCDIR)" "$(ROOTDIR)/include"
INCLUDE_PARMS = $(addprefix -I,$(INCLUDE_PATHS))

WARNINGS := -Wall -Wextra -Wshadow \
	-Wcast-align -Wwrite-strings -Wmissing-prototypes \
	-Wmissing-declarations -Wredundant-decls -Wnested-externs -Winline \
	-Wno-long-long -Wuninitialized -Wconversion -Wstrict-prototypes \
	-Wpointer-arith -Werror \
	$(NULL)

$(bin_PROGRAM)_SRCS := $(bin_PROGRAM).c pv/pv_stage3.c pv/pv_image.c \
	pv/pv_comp.c pv/pv_hdr.c pv/pv_ipib.c utils/crypto.c utils/file_utils.c \
	pv/pv_args.c utils/buffer.c pv/pv_comps.c pv/pv_error.c \
	pv/pv_opt_item.c \
	$(NULL)
$(bin_PROGRAM)_OBJS := $($(bin_PROGRAM)_SRCS:.c=.o)

ALL_CFLAGS += -std=gnu11 -DPKGDATADIR=$(PKGDATADIR) \
	$(GLIB2_CFLAGS) $(LIBCRYPTO_CFLAGS) \
	$(WARNINGS) \
	$(NULL)
ALL_CPPFLAGS += $(INCLUDE_PARMS)
LDLIBS += $(GLIB2_LIBS) $(LIBCRYPTO_LIBS)


ifneq ($(shell sh -c 'command -v pkg-config'),)
GLIB2_CFLAGS := $(shell pkg-config --silence-errors --cflags glib-2.0)
GLIB2_LIBS := $(shell pkg-config --silence-errors --libs glib-2.0)
LIBCRYPTO_CFLAGS := $(shell pkg-config --silence-errors --cflags libcrypto)
LIBCRYPTO_LIBS := $(shell pkg-config --silence-errors --libs libcrypto)
else
GLIB2_CFLAGS := -I/usr/include/glib-2.0 -I/usr/lib64/glib-2.0/include
GLIB2_LIBS := -lglib-2.0
LIBCRYPTO_CFLAGS :=
LIBCRYPTO_LIBS := -lcrypto
endif

BUILD_TARGETS := skip-$(bin_PROGRAM)
INSTALL_TARGETS := skip-$(bin_PROGRAM)
ifneq (${HAVE_OPENSSL},0)
ifneq (${HAVE_GLIB2},0)
BUILD_TARGETS := $(bin_PROGRAM)
INSTALL_TARGETS := install-$(bin_PROGRAM)
endif
endif

all: $(BUILD_TARGETS)

install: $(INSTALL_TARGETS)

$(bin_PROGRAM): $($(bin_PROGRAM)_OBJS)

skip-$(bin_PROGRAM):
	echo "  SKIP    $(bin_PROGRAM) due to unresolved dependencies"

install-$(bin_PROGRAM): $(bin_PROGRAM)
	$(INSTALL) -d -m 755 $(DESTDIR)$(USRBINDIR)
	$(INSTALL) -c $^ $(DESTDIR)$(USRBINDIR)

clean:
	$(RM) -f $($(bin_PROGRAM)_OBJS) $(bin_PROGRAM) .check-dep-$(bin_PROGRAM) .detect-openssl.dep.c

.PHONY: all install clean skip-$(bin_PROGRAM) install-$(bin_PROGRAM)

$($(bin_PROGRAM)_OBJS): .check-dep-$(bin_PROGRAM)

.detect-openssl.dep.c:
	echo "#include <openssl/evp.h>" > $@
	echo "#if OPENSSL_VERSION_NUMBER < 0x10100000L" >> $@
	echo "  #error openssl version 1.1.0 is required" >> $@
	echo "#endif" >> $@
	echo "static void __attribute__((unused)) test(void) {" >> $@
	echo "    EVP_MD_CTX *ctx = EVP_MD_CTX_new();" >> $@
	echo "    EVP_MD_CTX_free(ctx);" >> $@
	echo "}" >> $@

.check-dep-$(bin_PROGRAM): .detect-openssl.dep.c
	$(call check_dep, \
		"$(bin_PROGRAM)", \
		"glib.h", \
		"glib2-devel / libglib2.0-dev", \
		"HAVE_GLIB2=0")
	$(call check_dep, \
		"$(bin_PROGRAM)", \
		$^, \
		"openssl-devel / libssl-dev version >= 1.1.0", \
		"HAVE_OPENSSL=0", \
		"-I.")
	touch $@

=== zdev/src/Makefile ===
# Common definitions
include ../../common.mak

ALL_CPPFLAGS += -I ../include -std=gnu99 -Wno-unused-parameter \
	-Wno-missing-field-initializers

# Core
chzdev_objects += attrib.o chzdev.o device.o devnode.o devtype.o exit_code.o \
		  export.o hash.o inuse.o misc.o namespace.o opts.o path.o \
		  root.o select.o setting.o subtype.o table.o table_attribs.o \
		  table_types.o net.o firmware.o internal.o

# Devtype Helpers
chzdev_objects += blkinfo.o ccw.o ccwgroup.o findmnt.o modprobe.o module.o \
		  udev.o udev_ccw.o udev_ccwgroup.o iscsi.o

# DASD devtype
chzdev_objects += dasd.o

# FCP devtype
chzdev_objects += zfcp.o zfcp_host.o
chzdev_objects += scsi.o udev_zfcp_lun.o zfcp_lun.o

# QETH devtype
chzdev_objects += nic.o qeth.o qeth_auto.o

# CTC devtype
chzdev_objects += ctc.o ctc_auto.o

# LCS devtype
chzdev_objects += lcs.o lcs_auto.o

# Generic CCW devtype
chzdev_objects += generic_ccw.o


# Core
lszdev_objects += attrib.o lszdev.o device.o devnode.o devtype.o exit_code.o \
		  export.o hash.o inuse.o misc.o namespace.o opts.o path.o \
		  root.o select.o setting.o subtype.o table.o table_types.o \
		  net.o internal.o

# Devtype Helpers
lszdev_objects += blkinfo.o ccw.o ccwgroup.o findmnt.o modprobe.o module.o \
		  udev.o udev_ccw.o udev_ccwgroup.o iscsi.o

# DASD devtype
lszdev_objects += dasd.o

# FCP devtype
lszdev_objects += zfcp.o zfcp_host.o
lszdev_objects += scsi.o udev_zfcp_lun.o zfcp_lun.o

# QETH devtype
lszdev_objects += nic.o qeth.o qeth_auto.o

# CTC devtype
lszdev_objects += ctc.o ctc_auto.o

# LCS devtype
lszdev_objects += lcs.o lcs_auto.o

# Generic CCW devtype
lszdev_objects += generic_ccw.o

all: chzdev lszdev

chzdev_usage.c: chzdev_usage.txt
	$(SED) $< >$@ -e 's/\\/\\\\/g' -e 's/"/\\"/g' -e 's/^/"/g' \
		      -e 's/$$/\\n"/g'

.chzdev.o.d: chzdev_usage.c

lszdev_usage.c: lszdev_usage.txt
	$(SED) $< >$@ -e 's/\\/\\\\/g' -e 's/"/\\"/g' -e 's/^/"/g' \
		      -e 's/$$/\\n"/g'

.lszdev.o.d: lszdev_usage.c

chzdev.o: chzdev_usage.c
lszdev.o: lszdev_usage.c

libs = $(rootdir)/libutil/libutil.a

chzdev: $(chzdev_objects) $(libs)
lszdev: $(lszdev_objects) $(libs)

install: chzdev
	$(INSTALL) -d -m 755 $(DESTDIR)$(BINDIR)
	$(INSTALL) -c chzdev $(DESTDIR)$(BINDIR)
	$(INSTALL) -c lszdev $(DESTDIR)$(BINDIR)
ifeq ($(HAVE_DRACUT),1)
	$(INSTALL) -m 755 zdev-root-update.dracut \
		$(DESTDIR)$(TOOLS_LIBDIR)/zdev-root-update
endif

clean:
	@rm -f *.o chzdev lszdev chzdev_usage.c lszdev_usage.c gmon.out *.gcda *.gcno

.PHONY: all install clean

=== zipl/boot/Makefile ===
# Common definitions
include ../../common.mak

INCLUDE_PATHS := $(rootdir)/zipl/include $(rootdir)/include
INCLUDE_PARMS := $(addprefix -I,$(INCLUDE_PATHS))

ALL_CFLAGS = $(NO_PIE_CFLAGS) -Os -g $(INCLUDE_PARMS) \
	  -DS390_TOOLS_RELEASE=$(S390_TOOLS_RELEASE) \
	  -fno-builtin -ffreestanding -fno-asynchronous-unwind-tables \
	  -fno-delete-null-pointer-checks -fno-stack-protector \
	  -fexec-charset=IBM1047 -m64 -mpacked-stack \
	  -mstack-size=4096 -mstack-guard=128 -msoft-float \
	  -W -Wall -Wformat-security

FILES	= fba0.bin fba1b.bin fba2.bin \
	  eckd0_ldl.bin eckd0_cdl.bin \
	  eckd1.bin eckd1b.bin eckd2.bin \
	  tape0.bin \
	  eckd2dump_sv.bin tape2dump.bin fba2dump.bin eckd2dump_mv.bin

all: data.o data.h tape0.bin stage3.bin

# Prevent make from using some default rules...
%:	%.S

%.o:	%.S
	$(CC) $(ALL_CFLAGS) -c -o $@ $<

%.o:	%.c
	$(CC) $(ALL_CFLAGS) -c -o $@ $<

# Dependencies for the .lds generation
sources_lds_S = $(wildcard *.lds.S)
dependencies_lds_S = $(sources_lds_S:%.lds.S=.%.lds.d)
# Include all ".lds.d" dependency files for all make targets except for "clean"
ifneq ($(MAKECMDGOALS),clean)
-include $(dependencies_lds_S)
endif

%.lds: %.lds.S
	$(CPP) -Wp,-MD,.$@.d,-MT,$@ $(INCLUDE_PARMS) -P -C -o $@ $<

eckd2dump_sv.exec: \
	head.o stage2dump.o cio.o eckd2dump.o eckd2dump_sv.o \
	libc.o ebcdic.o sclp.o entry.o stage2.lds
eckd2dump_mv.exec: \
	head.o stage2dump.o cio.o eckd2dump.o eckd2dump_mv.o \
	libc.o ebcdic.o sclp.o entry.o stage2.lds
fba2dump.exec: \
	head.o stage2dump.o cio.o fba2dump.o \
	libc.o ebcdic.o sclp.o entry.o stage2.lds
tape2dump.exec: \
	head.o stage2dump.o cio.o tape2dump.o \
	libc.o ebcdic.o sclp.o entry.o stage2.lds
eckd2.exec: head.o stage2.o cio.o eckd2.o libc.o ebcdic.o menu.o sclp.o \
	    kdump2.o kdump.o entry.o stage2.lds
fba2.exec: head.o stage2.o cio.o fba2.o libc.o ebcdic.o menu.o sclp.o \
	   kdump2.o kdump.o entry.o stage2.lds
stage3.exec: head.o stage3.o kdump3.o libc.o ebcdic.o ebcdic_conv.o sclp.o \
	     sclp_stage3.o kdump.o entry.o stage3.lds

%.exec:	%.o
	STAGE=$$( \
		echo $@ | awk ' \
			match($$0,/[0-9]+b*/){ \
				print substr($$0,RSTART,RLENGTH) \
			}' \
	); \
	case $$STAGE in \
		0) SFLAGS="$(NO_PIE_LINKFLAGS) -nostdlib -Wl,-Ttext,0";; \
		1) SFLAGS="$(NO_PIE_LINKFLAGS) -nostdlib -Wl,-Ttext,0x18";; \
		1b) SFLAGS="$(NO_PIE_LINKFLAGS) -nostdlib -Wl,-Ttext,0xE000";; \
		2) SFLAGS="$(NO_PIE_LINKFLAGS) -nostdlib -Wl,-T,stage2.lds";; \
		3) SFLAGS="$(NO_PIE_LINKFLAGS) -nostdlib -Wl,-T,stage3.lds";; \
	esac; \
	$(LINK) $$SFLAGS -m64 $(filter %.o, $^) -o $@

%.bin:	%.exec
	$(OBJCOPY) -O binary \
		--only-section=.stage2.head \
		--only-section=.text.dummy \
		--only-section=.text.start \
		--only-section=.text \
		--only-section=.ex_table \
		--only-section=.data \
		--only-section=.rodata.str1.2 \
		--only-section=.rodata.cst8 \
		--only-section=.rodata \
		--only-section=.stage2dump.tail \
		--only-section=.eckd2dump_mv.tail \
		--only-section=.fixup \
		$< $@

stage3.bin:	stage3.exec
	$(OBJCOPY) -O binary \
		--only-section=.stage2.head \
		--only-section=.text.dummy \
		--only-section=.text.start \
		--only-section=.text \
		--only-section=.ex_table \
		--only-section=.data \
		--only-section=.rodata.str1.2 \
		--only-section=.rodata.cst8 \
		--only-section=.rodata \
		--only-section=.stage2dump.tail \
		--only-section=.eckd2dump_mv.tail \
		--only-section=.fixup \
		--pad-to=0xe000 \
		$< $@

data.o: $(FILES)
	$(LD) $(NO_PIE_LDFLAGS) -r -b binary -o data.o $(FILES)

data.h: data.o
	rm -f data.h
	$(NM) data.o | while read ADDR TYPE SYMBOL ; do \
				echo "extern char $$SYMBOL;" >>data.h; done

clean:
	rm -f *.o *.exec *.bin $(FILES) data.o data.h tape0.bin *.xxx *.yyy \
	      stage3.bin *.lds *.lds.d

.PHONY: all clean

=== debian/changelog ===
s390-tools (2.15.1-2) unstable; urgency=medium

  * Remove myself as a maintainer.

 -- Philipp Kern <pkern@debian.org>  Thu, 11 Feb 2021 07:18:40 +0100

s390-tools (2.15.1-1) unstable; urgency=medium

  * New upstream release
    - Install new tool lsstp.
    - Continue to skip out on zkey for now.

 -- Philipp Kern <pkern@debian.org>  Sat, 05 Dec 2020 11:55:08 +0100

s390-tools (2.14.0-2) unstable; urgency=medium

  * Bump debhelper compat to v13.
  * Install more binaries.

 -- Philipp Kern <pkern@debian.org>  Sun, 23 Aug 2020 12:46:01 -0400

=== debian/control ===
Source: s390-tools
Section: admin
Priority: important
Maintainer: Debian S/390 Team <debian-s390@lists.debian.org>
Uploaders: Bastian Blank <waldi@debian.org>
Build-Depends: debhelper-compat (= 13), libz-dev, quilt, gcc-multilib, libfuse-dev, libncurses-dev, libpfm4-dev, libssl-dev, libcurl4-openssl-dev, libcryptsetup-dev, libjson-c-dev
Standards-Version: 3.8.3
Homepage: http://www.ibm.com/developerworks/linux/linux390/s390-tools.html

Package: s390-tools
Architecture: s390x
Depends: ${shlibs:Depends}, ${misc:Depends}, perl, gawk
Recommends: sg3-utils
Description: Set of fundamental utilities for Linux on S/390
 The package contains:
  * dasdfmt, which is used to low-level format ECKD-DASDs with either
    the classic disk layout or the new zSeries compatible disk layout.
  * dasdview, which is used to display DASD and VTOC information or to
    dump the contents of a DASD to the console.
  * fdasd, which is used to create or modify partitions on ECKD-DASDs
    formatted with the zSeries compatible disk layout.
  * zipl, which is used to make either dasds or tapes bootable for
    system IPL or system dump.
  * zgetdump, which is used to retrieve system dumps from either tapes
    or dasds.

Package: s390-tools-udeb
Package-Type: udeb
Section: debian-installer
Priority: optional
Architecture: s390x
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Set of utilities for Linux on S/390
 This is a minimal package used by debian-installer.
 This package contains only the binaries dasdfmt and fdasd.

Package: ziomon
Priority: optional
Architecture: s390x
Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}, blktrace, rsync
Recommends: multipath-tools, lsscsi
Description: Performance analysis and reports for zFCP devices
 Tool set to collect data from zFCP devices for performance analysis
 and reporting.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_CPPFLAGS_MAINT_APPEND = -D_GNU_SOURCE
export DEB_CPPFLAGS_LDFLAGS_APPEND = -rdynamic

%:
	dh $@

override_dh_auto_clean:
	rm -f zipl/boot/.*.d
	dh_auto_clean

override_dh_auto_build:
	make V=1

override_dh_auto_install:
	make install DESTDIR=$(CURDIR)/debian/tmp
	dh_install

override_dh_fixperms:
	chmod 0644 $(CURDIR)/debian/s390-tools/lib/s390-tools/stage3.bin
	dh_fixperms

## s390-tools 2.16.0

=== Makefile ===
ARCH := $(shell uname -m | sed -e s/i.86/i386/ -e s/sun4u/sparc64/ -e s/arm.*/arm/ -e s/sa110/arm/)

# Include common definitions
include common.mak

LIB_DIRS = libvtoc libutil libzds libdasd libvmdump libccw libvmcp libekmfweb
TOOL_DIRS = zipl zdump fdasd dasdfmt dasdview tunedasd \
	   tape390 osasnmpd qetharp ip_watcher qethconf scripts zconf \
	   vmconvert vmcp man mon_tools dasdinfo vmur cpuplugd ipl_tools \
	   ziomon iucvterm hyptop cmsfs-fuse qethqoat zfcpdump zdsfs cpumf \
	   systemd hmcdrvfs cpacfstats zdev dump2tar zkey netboot etc zpcictl \
	   genprotimg lsstp hsci

SUB_DIRS = $(LIB_DIRS) $(TOOL_DIRS)

all: $(TOOL_DIRS)
clean: $(TOOL_DIRS)
install: $(TOOL_DIRS)

#
# For simple "make" we explicitly set the MAKECMDGOALS to "all".
#
ifeq ($(MAKECMDGOALS),)
MAKECMDGOALS = all
endif

#
# We have to build the libraries before the tools are built. Otherwise
# the tools would trigger parallel "make -C" builds for libraries in
# case of "make -j".
#
# MAKECMDGOALS contains the list of goals, e.g. "clean all". We use
# "foreach" to generate a ";" separated list of "make -C <target>".
# For example the the expansion for "make clean all" is:
#
# $(MAKE) -C $@ [..] clean ;  $(MAKE) -C $@ [...] all ;
#
# This ensures that the commandline targets are serialized and also "make -j"
# works as expected, e.g. "make clean all -j 20".
#

$(TOOL_DIRS): $(LIB_DIRS)
	$(foreach goal,$(MAKECMDGOALS), \
		$(MAKE) -C $@ TOPDIR=$(TOPDIR) ARCH=$(ARCH) $(goal) ;)
.PHONY: $(TOOL_DIRS)

$(LIB_DIRS):
	$(foreach goal,$(MAKECMDGOALS), \
		$(MAKE) -C $@ TOPDIR=$(TOPDIR) ARCH=$(ARCH) $(goal) ;)
.PHONY: $(LIB_DIRS)

=== cmsfs-fuse/Makefile ===
#!/usr/bin/make -f

include ../common.mak

ifeq (${HAVE_FUSE},0)

all:
	$(SKIP) HAVE_FUSE=0

install:
	$(SKIP) HAVE_FUSE=0

else

check_dep:
	$(call check_dep, \
		"cmsfs-fuse", \
		"fuse.h", \
		"fuse-devel or libfuse-dev", \
		"HAVE_FUSE=0")

all: check_dep cmsfs-fuse

ifneq ($(shell sh -c 'command -v pkg-config'),)
FUSE_CFLAGS = $(shell pkg-config --silence-errors --cflags fuse)
FUSE_LDLIBS = $(shell pkg-config --silence-errors --libs fuse)
else
FUSE_CFLAGS = -D_FILE_OFFSET_BITS=64 -I/usr/include/fuse
FUSE_LDLIBS = -lfuse
endif
ALL_CFLAGS += -DHAVE_SETXATTR $(FUSE_CFLAGS)
LDLIBS += $(FUSE_LDLIBS) -lm

OBJECTS = cmsfs-fuse.o dasd.o amap.o config.o

CMSFS_FUSE_DIR = $(SYSCONFDIR)/cmsfs-fuse
CONFIG_FILES = filetypes.conf

libs = $(rootdir)/libutil/libutil.a

cmsfs-fuse: $(OBJECTS) $(libs)

install: all
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 cmsfs-fuse \
		$(DESTDIR)$(USRBINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 cmsfs-fuse.1 \
		$(DESTDIR)$(MANDIR)/man1
	$(INSTALL) -g $(GROUP) -o $(OWNER) -d $(DESTDIR)$(CMSFS_FUSE_DIR)
	for cnf in $(CONFIG_FILES); do \
	  $(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 etc/$$cnf $(DESTDIR)$(CMSFS_FUSE_DIR) ; \
	done

endif

clean:
	rm -f cmsfs-fuse *.o

.PHONY: all install clean check_dep

=== cpumf/Makefile ===
include ../common.mak

BIN_FILES = lscpumf chcpumf
MAN_FILES = lscpumf.1 chcpumf.8

all: $(BIN_FILES)

libs =	$(rootdir)/libutil/libutil.a

lscpumf: lscpumf.o $(libs)
chcpumf: chcpumf.o $(libs)

install: all install-man
	$(INSTALL) -d -m 755 $(DESTDIR)$(BINDIR) $(DESTDIR)$(MANDIR)/man8
	for binf in $(BIN_FILES); do \
	 $(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 $$binf $(DESTDIR)$(BINDIR); \
	done

clean:
	rm -f *.o *~ $(BIN_FILES) core

install-man:
	for man in $(MAN_FILES); do \
	  msection=`echo $$man |sed 's/.*\.\([1-9]\)$$/man\1/'` ; \
	  $(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 -D man/$$man $(DESTDIR)$(MANDIR)/$$msection/$$man ; \
	done

.PHONY: all install clean

=== cpuplugd/Makefile ===
include ../common.mak

all: cpuplugd

LDLIBS += -lm

OBJECTS = daemon.o cpu.o info.o terms.o config.o main.o getopt.o mem.o

cpuplugd: $(OBJECTS)
	$(LINK) $(ALL_LDFLAGS) $^ $(LDLIBS) -o $@

clean:
	rm -f cpuplugd $(OBJECTS)

install: all
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 cpuplugd \
		$(DESTDIR)$(USRSBINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 man/cpuplugd.8 \
		$(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 man/cpuplugd.conf.5 \
		$(DESTDIR)$(MANDIR)/man5

.PHONY: all install clean

=== dasdview/Makefile ===
include ../common.mak

libs =	$(rootdir)/libdasd/libdasd.a \
	$(rootdir)/libzds/libzds.a \
	$(rootdir)/libvtoc/libvtoc.a \
	$(rootdir)/libutil/libutil.a

ifneq (${HAVE_CURL},0)

check_dep:
	$(call check_dep, \
		"dasdview", \
		"curl/curl.h", \
		"curl-devel or libcurl-dev", \
		"HAVE_CURL=0")

BUILDTARGET = check_dep

ifneq ($(shell sh -c 'command -v pkg-config'),)
CURL_CFLAGS = $(shell pkg-config --silence-errors --cflags libcurl)
CURL_LDLIBS = $(shell pkg-config --silence-errors --libs libcurl)
else
CURL_CFLAGS = -I/usr/include/s390x-linux-gnu/curl
CURL_LDLIBS = -lcurl
endif # shell

endif # HAVE_CURL

BUILDTARGET += dasdview

ALL_CPPFLAGS += -DSYSFS
ALL_CFLAGS += $(CURL_CFLAGS)
LDLIBS += $(CURL_LDLIBS)

all: $(BUILDTARGET)

dasdview: dasdview.o $(libs)

install: all
	$(INSTALL) -d -m 755 $(DESTDIR)$(BINDIR) $(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 dasdview $(DESTDIR)$(BINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 dasdview.8 \
		$(DESTDIR)$(MANDIR)/man8

clean:
	rm -f *.o *~ dasdview core

.PHONY: all install clean

=== hmcdrvfs/Makefile ===
#!/usr/bin/make -f

include ../common.mak

ifeq (${HAVE_FUSE},0)

all:
	$(SKIP) HAVE_FUSE=0

install:
	$(SKIP) HAVE_FUSE=0

else

check_dep:
	$(call check_dep, \
		"hmcdrvfs", \
		"fuse.h", \
		"fuse-devel or libfuse-dev", \
		"HAVE_FUSE=0")

ifneq ($(shell sh -c 'command -v pkg-config'),)
FUSE_CFLAGS = $(shell pkg-config --silence-errors --cflags fuse)
FUSE_LDLIBS = $(shell pkg-config --silence-errors --libs fuse)
else
FUSE_CFLAGS = -D_FILE_OFFSET_BITS=64 -I/usr/include/fuse
FUSE_LDLIBS = -lfuse
endif
ALL_CFLAGS += -DFUSE_USE_VERSION=26 -D_LARGEFILE_SOURCE $(FUSE_CFLAGS)
LDLIBS += $(FUSE_LDLIBS) -lpthread -lrt -ldl -lm

OBJECTS = hmcdrvfs.o

libs = $(rootdir)/libutil/libutil.a

all: check_dep hmcdrvfs

$(OBJECTS): Makefile

hmcdrvfs: $(OBJECTS) $(libs)

install: all install-scripts
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 hmcdrvfs \
		$(DESTDIR)$(USRBINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 hmcdrvfs.1 \
		$(DESTDIR)$(MANDIR)/man1
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 lshmc.8 \
		$(DESTDIR)$(MANDIR)/man8

install-scripts: lshmc
	@for i in $^; do \
		cat $$i | \
		sed -e 's/%S390_TOOLS_VERSION%/$(S390_TOOLS_RELEASE)/' \
		>$(DESTDIR)$(USRSBINDIR)/$$i; \
		chown $(OWNER).$(GROUP) $(DESTDIR)$(USRSBINDIR)/$$i; \
		chmod 755 $(DESTDIR)$(USRSBINDIR)/$$i; \
	done

endif

clean:
	rm -f hmcdrvfs *.o

.PHONY: all install install-scripts clean check_dep

=== iucvterm/Makefile ===
#! /usr/bin/make -f

include ../common.mak


GETTEXT_TEXTDOMAIN = iucvterm
export GETTEXT_TEXTDOMAIN


SUBDIRS = src po doc bin etc test
RECURSIVE_TARGETS = all-recursive install-recursive clean-recursive \
                    check-recursive


all: all-recursive
check: check-recursive
install: all install-recursive
clean: clean-recursive


$(RECURSIVE_TARGETS):
	@target=`echo $@ |sed s/-recursive//`; \
	for d in $(SUBDIRS); do \
		(cd $$d && $(MAKE) $$target) || exit 1; \
	done


.PHONY: install clean

=== libekmfweb/Makefile ===
--- 
+++ 
@@ -77,11 +77,11 @@
 	ln -srf libekmfweb.so.$(VERSION) libekmfweb.so
 
 install-libekmfweb.so.$(VERSION): libekmfweb.so.$(VERSION)
-	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 -T libekmfweb.so.$(VERSION) $(DESTDIR)$(USRLIB64DIR)/libekmfweb.so.$(VERSION)
-	ln -srf $(DESTDIR)$(USRLIB64DIR)/libekmfweb.so.$(VERSION) $(DESTDIR)$(USRLIB64DIR)/libekmfweb.so.$(VERM)
-	ln -srf $(DESTDIR)$(USRLIB64DIR)/libekmfweb.so.$(VERSION) $(DESTDIR)$(USRLIB64DIR)/libekmfweb.so
+	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 -T libekmfweb.so.$(VERSION) $(DESTDIR)$(SOINSTALLDIR)/libekmfweb.so.$(VERSION)
+	ln -srf $(DESTDIR)$(SOINSTALLDIR)/libekmfweb.so.$(VERSION) $(DESTDIR)$(SOINSTALLDIR)/libekmfweb.so.$(VERM)
+	ln -srf $(DESTDIR)$(SOINSTALLDIR)/libekmfweb.so.$(VERSION) $(DESTDIR)$(SOINSTALLDIR)/libekmfweb.so
 	$(INSTALL) -d -m 770 $(DESTDIR)$(USRINCLUDEDIR)/ekmfweb
-	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 $(rootdir)include/ekmfweb/ekmfweb.h $(DESTDIR)$(USRINCLUDEDIR)/ekmfweb
+	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 $(rootdir)include/ekmfweb/ekmfweb.h $(DESTDIR)$(USRINCLUDEDIR)/ekmfweb
 
 install: all $(INSTALL_TARGETS)

=== libutil/Makefile ===
include ../common.mak

lib = libutil.a

examples =	util_base_example \
		util_panic_example \
		util_path_example \
		util_scandir_example \
		util_file_example \
		util_libc_example \
		util_opt_example \
		util_opt_command_example \
		util_prg_example \
		util_rec_example

all: $(lib)
examples: $(lib) $(examples)

objects =	util_base.o \
		util_path.o \
		util_scandir.o \
		util_file.o \
		util_libc.o \
		util_list.o \
		util_opt.o \
		util_panic.o \
		util_part.o \
		util_prg.o \
		util_proc.o \
		util_rec.o \
		util_sys.o

util_base_example: util_base_example.o $(lib)
util_panic_example: util_panic_example.o $(lib)
util_path_example: util_path_example.o $(lib)
util_scandir_example: util_scandir_example.o $(lib)
util_file_example: util_file_example.o $(lib)
util_libc_example: util_libc_example.o $(lib)
util_opt_example: util_opt_example.o $(lib)
util_opt_command_example: util_opt_command_example.o $(lib)
util_panic_example: util_panic_example.o $(lib)
util_prg_example: util_prg_example.o $(lib)
util_rec_example: util_rec_example.o $(lib)

$(lib): $(objects)
$(lib): ALL_CFLAGS += -fPIC

install: all

clean:
	rm -f *.o $(lib) $(examples)

=== libvmdump/Makefile ===
include ../common.mak

lib = libvmdump.a

all: $(lib)

objects = register_content.o dump.o lkcd_dump.o register_content.o \
	  vmdump_convert.o vm_dump.o

$(lib): $(objects)

install: all

clean:
	rm -f *.o $(lib)

=== qetharp/Makefile ===
include ../common.mak

all: qetharp

qetharp: qetharp.o

install: all
	$(INSTALL) -d -m 755 $(DESTDIR)$(MANDIR)/man8 $(DESTDIR)$(BINDIR)
	$(INSTALL) -m 755 qetharp $(DESTDIR)$(BINDIR)
	$(INSTALL) -m 644 qetharp.8 $(DESTDIR)$(MANDIR)/man8

clean:
	rm -f qetharp *.o *~ core

.PHONY: all install clean

=== scripts/Makefile ===
include ../common.mak

SCRIPTS	= dbginfo.sh zfcpdbf zipl-switch-to-blscfg scsi_logging_level
MAN_PAGES = dbginfo.sh.1 zfcpdbf.1 zipl-switch-to-blscfg.1

all:

install:
	$(INSTALL) -d -m 755 $(DESTDIR)$(BINDIR) $(DESTDIR)$(MANDIR)/man1
	@for i in $(SCRIPTS); \
	do \
		cat $$i | \
		sed -e 's/%S390_TOOLS_VERSION%/$(S390_TOOLS_RELEASE)/' \
		>$(DESTDIR)$(BINDIR)/$$i; \
		chown $(OWNER):$(GROUP) $(DESTDIR)$(BINDIR)/$$i; \
		chmod 755 $(DESTDIR)$(BINDIR)/$$i; \
	done

	sed -e 's/%S390_TOOLS_VERSION%/$(S390_TOOLS_RELEASE)/' cpictl > \
		$(DESTDIR)$(TOOLS_LIBDIR)/cpictl
	chown $(OWNER):$(GROUP) $(DESTDIR)$(TOOLS_LIBDIR)/cpictl
	chmod 775 $(DESTDIR)$(TOOLS_LIBDIR)/cpictl

	@for i in $(MAN_PAGES); \
	do \
		$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 $$i \
		$(DESTDIR)$(MANDIR)/man1; \
	done

clean:

.PHONY: all install clean

=== debian/changelog ===
s390-tools (2.16.0-2) unstable; urgency=medium

  * Add missing build-dependency on libglib2.0-dev. (Closes: #992249)

 -- Philipp Kern <pkern@debian.org>  Wed, 18 Aug 2021 03:26:50 -0400

s390-tools (2.16.0-1) unstable; urgency=medium

  * New upstream release.
  * Install hsci, used to show and control HiperSockets Converged Interfaces.

 -- Philipp Kern <pkern@debian.org>  Sun, 15 Aug 2021 08:02:00 -0400

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: important
 Maintainer: Debian S/390 Team <debian-s390@lists.debian.org>
 Uploaders: Bastian Blank <waldi@debian.org>
-Build-Depends: debhelper-compat (= 13), libz-dev, quilt, gcc-multilib, libfuse-dev, libncurses-dev, libpfm4-dev, libssl-dev, libcurl4-openssl-dev, libcryptsetup-dev, libjson-c-dev
+Build-Depends: debhelper-compat (= 13), libz-dev, quilt, gcc-multilib, libglib2.0-dev, libfuse-dev, libncurses-dev, libpfm4-dev, libssl-dev, libcurl4-openssl-dev, libcryptsetup-dev, libjson-c-dev
 Standards-Version: 3.8.3
 Homepage: http://www.ibm.com/developerworks/linux/linux390/s390-tools.html

=== debian/rules ===
--- 
+++ 
@@ -7,7 +7,7 @@
 	dh $@
 
 override_dh_auto_clean:
-	rm -f zipl/boot/.*.d
+	rm -f zipl/boot/.*.d iucvterm/doc/iucvtty.8
 	dh_auto_clean
 
 override_dh_auto_build:

## s390-tools 2.17.0

=== hsavmcore/Makefile ===
#
# Copyright IBM Corp. 2021
#
# s390-tools is free software; you can redistribute it and/or modify
# it under the terms of the MIT license. See LICENSE for details.
#

include ../common.mak

ALL_CPPFLAGS += -D_FILE_OFFSET_BITS=64

ifeq (${HAVE_FUSE},0)

all:
	$(SKIP) HAVE_FUSE=0

install:
	$(SKIP) HAVE_FUSE=0

else # HAVE_FUSE

#
# FUSE
#
ifneq ($(shell sh -c 'command -v pkg-config'),)
  FUSE_CFLAGS = $(shell pkg-config --silence-errors --cflags fuse)
  FUSE_LDLIBS = $(shell pkg-config --silence-errors --libs fuse)
else
  FUSE_CFLAGS = -I/usr/include/fuse
  FUSE_LDLIBS = -lfuse
endif

#
# systemd
#
ifneq (${HAVE_SYSTEMD},0)
  ifeq ($(call check_header_prereq,"systemd/sd-daemon.h"),yes)
    ifneq ($(shell sh -c 'command -v pkg-config'),)
      SYSTEMD_CFLAGS = $(shell pkg-config --silence-errors --cflags libsystemd)
      SYSTEMD_LDLIBS = $(shell pkg-config --silence-errors --libs libsystemd)
    else
      SYSTEMD_CFLAGS =
      SYSTEMD_LDLIBS = -lsystemd
    endif
    ALL_CPPFLAGS += -DHAVE_SYSTEMD
  else
    $(warning "systemd support disabled")
  endif
endif

ALL_CFLAGS += $(FUSE_CFLAGS) $(SYSTEMD_CFLAGS)
LDLIBS += $(FUSE_LDLIBS) $(SYSTEMD_LDLIBS) -lpthread

sources := $(wildcard *.c)
objects := $(patsubst %.c,%.o,$(sources))

libs = $(rootdir)/libutil/libutil.a

all: hsavmcore

hsavmcore: $(objects) $(libs)
	$(LINK) $(ALL_LDFLAGS) $^ $(LDLIBS) -o $@

overlay.o: check-dep-fuse overlay.c overlay.h

check-dep-fuse:
	$(call check_dep, \
		"hsavmcore", \
		"fuse.h", \
		"fuse-devel or libfuse-dev", \
		"HAVE_FUSE=0")

install: all
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 hsavmcore \
		$(DESTDIR)$(USRSBINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 man/hsavmcore.8 \
		$(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 man/hsavmcore.conf.5 \
		$(DESTDIR)$(MANDIR)/man5

endif # HAVE_FUSE

clean:
	rm -f hsavmcore $(objects)

.PHONY: all install clean

=== debian/changelog ===
s390-tools (2.17.0-0ubuntu2) impish; urgency=medium

  * d/p/0001-libkmipclient-Fix-parsing-of-hex-values-for-XML-and-.patch
    Fix parsing of hex values for XML and JSON encoding in libkmipclient.
    (LP: #1938947)

 -- Frank Heimes <frank.heimes@canonical.com>  Wed, 08 Sep 2021 09:10:54 +0200

s390-tools (2.17.0-0ubuntu1) impish; urgency=medium

  * New upstream release. LP: #1934988
    + New binaries hsavmcore and lshwc
    + New library libkmipclient
    + New build-dependency on libxml2-dev
  * Refresh the patches
  * Remove unapplied patch disable.patch.DEBIAN

 -- Simon Chopin <simon.chopin@canonical.com>  Fri, 09 Jul 2021 17:01:10 +0200

s390-tools (2.16.0-0ubuntu1) hirsute; urgency=medium

  * New upstream release. LP: #1914574
  * Drop patches applied upstream.
  * Compile with ZDEV_ALWAYS_UPDATE_INITRD=1 option. This fixes calls to
    chzdev to trigger update-initramfs -u. LP: #1892367
  * Set install path via make variables, instead of patching source
    Makefiles.
  * Update homepage to github.com.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 24 Feb 2021 05:49:54 +0000

s390-tools (2.15.1-1ubuntu3) hirsute; urgency=medium

  * No-change rebuild to drop the udeb package.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 22 Feb 2021 10:36:10 +0100

s390-tools (2.15.1-1ubuntu2) hirsute; urgency=medium

  * No change rebuild with fixed ownership.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 18 Feb 2021 00:03:00 +0000

s390-tools (2.15.1-1ubuntu1) hirsute; urgency=low

  * Update debian/watch for new ibm-s390-linux repo
  * Update debian/control for [XC-]Package-Type
  * Merge from Debian unstable. Remaining changes:
    - keep providing zkey
    - split some tools into individuall packages
    - Drop udevadm-path.patch
    - Drop ziomon package
    - Linux on z Systems naming
    - 0001-ziomon-Use-exit-code-0-for-version-and-help.patch
    - 0001-zkey-add-initramfs-hook.patch
    - 0001-zkey-on-Ubuntu-use-default-benchmarked-Argon2i-with-.patch
    - 0001-dumpconf-Don-t-run-the-service-in-LXC.patch
    - update-install-paths.patch
    - 0010-no-pie-is-not-a-valid-option-for-ld.patch
    - s390-tools-lp1903984-hirsute.patch

 -- Lukas Märdian <slyon@ubuntu.com>  Mon, 08 Feb 2021 12:46:12 +0100

s390-tools (2.15.1-0ubuntu6) hirsute; urgency=medium

  * debian/patches/s390-tools-lp1903984-hirsute.patch
    zcryptstats: Fix handling of partial results with many domains
    Thanks to Ingo Franzki (LP: #1903984)

 -- Frank Heimes <frank.heimes@canonical.com>  Tue, 19 Jan 2021 18:58:26 +0100

s390-tools (2.15.1-0ubuntu5) hirsute; urgency=medium

  * No-change rebuild to bring the version in sync with
    s390-tools-signed.

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Fri, 08 Jan 2021 21:32:29 -0500

s390-tools (2.15.1-0ubuntu4) hirsute; urgency=medium

  * No-change upload due to net-snmp transition.

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Thu, 07 Jan 2021 15:11:33 -0500

s390-tools (2.15.1-0ubuntu3) hirsute; urgency=medium

  * Fix FTBFS via d/p/0010-no-pie-is-not-a-valid-option-for-ld.patch
    "-no-pie" is not a valid option of ld and never has been (LP: #1907789)

 -- Lukas Märdian <lukas.maerdian@canonical.com>  Thu, 07 Jan 2021 12:16:59 +0100

s390-tools (2.15.1-0ubuntu2) hirsute; urgency=medium

  * Package libekmfweb library.
  * Do not use /usr/lib64 prefix.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 18 Nov 2020 14:23:24 +0000

s390-tools (2.15.1-0ubuntu1) hirsute; urgency=medium

  * New upstream release. LP: #1902865, LP: #1902047, LP: #1892824, LP: #1887920, LP: #1887806
  * Drop .triggers, and initramfs override. Triggers to update initramfs
    are desired in both packages that ship hooks.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 12 Nov 2020 15:10:44 +0000

s390-tools (2.14.0-2ubuntu1) hirsute; urgency=medium

  * Merge from Debian unstable (LP: #1903688).  Remaining changes:
    - lower priority to optional
    - add libsnmp-dev, libglib2.0-dev build-deps
    - add support for signed zipl
    - use z Systems branding in descriptions
    - package cpuplugd, osasnmpd, statd, zkey
    - drop ziomon package, shipped in the main package
    - ship zdev in udeb
    - update copyright file
    - fix kernel installer script integration, to skip calling zipl without initrd
    - load monwriter kernel module for mon_statd/mon_fsstatd
    - do not run dumpconf in lxc
    - ziomon change exit code to 0 for version and help
    - add zkey initramfs hook
    - change zkey default back to argon2i
    - drop patch that disables building osasnmpd
    - drop udevadm-path.patch to init script, systemd units are used instead
    - enable hardening
    - enable initramfs & dracut integration
    - setup users/groups for mon_*, iucvterm, zkey
    - install more utilities and zdev initramfs integration
    - setup crashkernel integration
  * Update debian/not-installed file for additional files in debian/tmp
  * debian/rules:
    - drop unneeded "--parallel --with systemd" dh args
    - clean zipl/boot/.stage*.d files
    - avoid dh_installinitramfs to install additional triggers
  * s390-tools.docs: ship CHANGELOG.md (as Debian does)

 -- Lukas Märdian <lukas.maerdian@canonical.com>  Mon, 09 Nov 2020 16:04:40 +0100

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export DEB_CPPFLAGS_MAINT_APPEND = -D_GNU_SOURCE
export DEB_LDFLAGS_MAINT_APPEND=-rdynamic
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

options= V=1 HAVE_SNMP=1 SYSTEMDSYSTEMUNITDIR=/lib/systemd/system ZDEV_ALWAYS_UPDATE_INITRD=1 ZKEYKMSPLUGINDIR=/usr/libexec/zkey USRLIB64DIR=/usr/lib/s390x-linux-gnu

# Enable signing in Launchpad Only for now
SIGN_SIPL=
ifneq (,$(wildcard /CurrentlyBuilding))
SIGN_SIPL=yes
endif
SIGN_SIPL=yes

%:
	dh $@

override_dh_install:
	# no dracut
	rm -f debian/tmp/lib/s390-tools/zdev-root-update
	chmod -x debian/tmp/etc/*/*.conf debian/tmp/lib/s390-tools/zfcpdump/zfcpdump-initrd
	dh_install -ps390-tools-cpuplugd
	dh_install -ps390-tools-statd
	dh_install -ps390-tools-osasnmpd
	dh_install -ps390-tools-zkey -ps390-tools-zkey-udeb
	dh_install $(if $(SIGN_SIPL),-Xstage3.bin) -Xcpuplugd -Xosasnmpd -Xprocd -Xfsstatd -X60-readahead.rules -Xzkey
	$(if $(SIGN_SIPL),echo 'signing:Depends=s390-tools-signed (= $(DEB_VERSION))') >> debian/s390-tools.substvars

override_dh_auto_clean:
	rm -f zipl/boot/.*.d
	dh_auto_clean -- $(options)

override_dh_auto_build:
	dh_auto_build -- $(options)

override_dh_auto_install:
	HAVE_INITRAMFS=1 HAVE_DRACUT=1 dh_auto_install -- $(options)

signing=debian/s390-tools-$(DEB_VERSION)-signing/
signingv=$(signing)/$(DEB_VERSION)
signing_tar=$(DEB_SOURCE)_$(DEB_VERSION)_$(DEB_HOST_ARCH).tar.gz
override_dh_builddeb:
	dh_builddeb
	mkdir -p $(signingv)/control
	echo 'tarball' >$(signingv)/control/options
	cp debian/tmp/lib/s390-tools/stage3.bin $(signingv)/stage3.bin.sipl
	tar -C $(signing) -czvf $(CURDIR)/../$(signing_tar) .
	dpkg-distaddfile $(signing_tar) raw-signing -
override_dh_clean:
	dh_clean
	rm -rf $(signing)
